#include <stdlib.h>

#include <cd.h>
#include <cdmf.h>

#include <lua.h>

#include "cdluapvt.h"


#define ignore(_) (void *)(_)


static void *cdmetafile_checkdata(int param)
{
  lua_Object data;

  data = lua_getparam(param);
  if (!lua_isstring(data))
    lua_error("cdCreateCanvas CD_METAFILE: data should be of type string!");

  return lua_getstring(data);
}

static int metafile_sizecb(cdContext *driver, int w, int h, double mm_w, double mm_h);

static cdCallbackLUA cdluamfcb[1] = 
{{
  -1,
  "CD_SIZECB",
  (cdCallback)metafile_sizecb
}};

static cdContextLUA cdluamfctx = 
{
  0,
  "CD_METAFILE",
  cdContextMetafile,
  NULL,
  cdmetafile_checkdata,
  cdluamfcb,
  1
};

static int metafile_sizecb(cdContext *driver, int w, int h, double mm_w, double mm_h)
{
  lua_Object func, result;
  int result_i;
  ignore(driver);

  lua_beginblock();
  func = lua_getref(cdluamfcb[CD_SIZECB].lock);

  lua_pushnumber( cdluamfctx.id);
  lua_pushnumber( w);
  lua_pushnumber( h);
  lua_pushnumber( mm_w);
  lua_pushnumber( mm_h);
  lua_callfunction(func);

  result = lua_getresult(1);
  if (!lua_isnumber(result))
    lua_error("cdPlay: CD_SIZECB: invalid return value!");
  result_i = (int) lua_getnumber(result);

  lua_endblock();
  
  return result_i;
}

void cdluamf_open(void)
{
  cdluaAddContext(&cdluamfctx);
}

