// ManJS Functions
// Version 1.2
// http://www.tecgraf.puc-rio.br/~scuri/manjs
// Created by Antonio E. Scuri
// scuri@tecgraf.puc-rio.br

/////////////////////////////////////
// Private Functions
/////////////////////////////////////


// Used only by the index.html file
// Creates the frames with a custom start up contents based on the first topic title
function manCreateFrames(name, size)
{
	top.document.write(
    "<frameset border='0' rows='50,*'>\n",
    "  <frameset cols='", size, ",*'>\n",
    "    <frame NORESIZE SRC='man/man_title.html' SCROLLING='no' >\n",
    "    <frame NORESIZE SRC='man/man_bar.html' NAME='bar' SCROLLING='no'>\n",
    "  </frameset>\n",
    "  <frameset cols='", size, ",*'>\n",
    "    <frame NORESIZE SRC='", name, "_tree.html' NAME='tree'>\n",
    "    <frame NORESIZE SRC='", name, ".html' NAME='cont'>\n",
    "  </frameset>\n",
    "  <noframes>",
    "    <body>",
    "    <p>This page uses frames, but your browser doesn't support them.</p>",
    "    </body>",
    "  </noframes>",
    "</frameset>\n");
}

// Used only by the manTreeOpen function to update the current pointer
function manSetPointer(name)
{
	if (top.manImageArray == null)
	  return;
	  
	if (top.manPath == -1)
	{
	  // Netscape does not includes the man/ on this path because the tree file is in another folder
	  
  	top.manImageArray[name + "_img"].src = "fill.gif";
  	var new_path = top.manImageArray[name + "_img"].src;
  	if (top.manImageArray[name + "_img"].complete)
    	top.manPath = 0;
    else
    	top.manPath = 1;
	}
	
	var man_path = "";
	if (top.manPath == 1)
	  man_path = "man/";
	
	top.manImageArray[top.manCurName + "_img"].src = man_path + "fill.gif";
	top.manImageArray[name + "_img"].src = man_path + "pointer.gif";
  top.manCurName = name;
}

function manUpdatePointer()
{
  manSetPointer(top.manCurName)
}

// Used only by the manCreateBar function to create the link to the tree.
function manLoadTree(name) 
{
  top.tree.location.href = "../" + name + "_tree.html";
  top.cont.location.href = "../" + name + ".html";
}

// Used only by the man_bar.html file. Creates the topic bar from the configuration file topic list
function manCreateBar(bar_tree_array, bar_title_array)
{
	bar.manBar = "<table height='100%' border='0' cellpadding='0' cellspacing='0'>\n";
	
	var bar_count = bar_tree_array.length;
		
	bar.manBar += "<tr>\n";
	for (i = 0; i < bar_count; i++)
	{
 	  bar.manBar += "<td width='20'></td>\n";
 	  bar.manBar += "<td align='center'><a href='javascript:parent.manLoadTree(\"" + bar_tree_array[i] + "\")'><font size='2' face='Helvetica,Arial'><strong>" + bar_title_array[i] + "</strong></font></a></td>\n";
	}
	bar.manBar += "</tr>\n";
	
	var img;
	
	bar.manBar += "<tr>\n";
	for (i = 0; i < bar_count; i++)
	{
		if (top.manCurName == bar_tree_array[i])
		  img = "pointer";
		else
      img = "fill";
			
 	  bar.manBar += "<td width='20'></td>\n";
 	  bar.manBar += "<td align='center' height='20'><img src='" + img + ".gif' width='20' height='12' name='" + bar_tree_array[i] + "_img'></td>\n";
		
	}
	bar.manBar += "</tr>\n";
	
	bar.manBar += "</table>\n";
	bar.document.write(bar.manBar);
	
  top.manImageArray = bar.document.images;
	top.manPath = -1;
}

/////////////////////////////////////
// Public Functions
/////////////////////////////////////

manNoBullet = 0
manHasBullet = 1
manSkipBullet = 2

function manLoadCont(name, cont, book) 
{
  if (cont.charAt(0) == "." && cont.charAt(1) == ".")
    top.tree.location.href = "../" + name + "_tree.html";
  else
    top.tree.location.href = name + "_tree.html";
  
  top.cont.location.href = cont + ".html" + (book? "#" + book: "");
}

function manTreeOpen(name)
{
  var title = ""
	var bar_count = top.manBarTreeArray.length;
	
	for (i = 0; i < bar_count; i++)
	{
	  if (top.manBarTreeArray[i] == name)
	  {
      title = top.manBarTitleArray[i];
      break;
    }
  }
  
	tree.document.write(
		"<html>\n\n",
		"<head>\n",
		"<base target='cont'>\n",
		"</head>\n\n",
		"<body background='man/background.gif' bgcolor='#C0C0C0' link='#000080' vlink='#000080'>\n",
		"<p align='center'><font face='Helvetica,Arial'><strong>", title, "</strong></font></p>\n\n");
	
 	tree.manTree = "<table border='0' cellpadding='3' cellspacing='0'>\n";
	
	manSetPointer(name)
}

function manTreeClose(copyright)
{
 	tree.manTree += "</table>\n";
  	
	tree.document.write(tree.manTree);
	
  if (copyright)
  {
  	tree.document.write(
  		"<p>&nbsp;</p>\n",
  		"<table width='100%' border='0' cellpadding='0'>\n",
  		"<tr>\n",
  		"	 <td align='center' valign='bottom'>\n",
  		"    <a href='", top.manCopyrightLink, "' target='_top'><img src='", top.manCopyrightImage, "' border='0'></a><br>\n",
  		"	   <font size='2'><strong>", top.manCopyrightDate, "<br>", top.manCopyrightName, "<br>\n",
  		"	   Rev.: ", top.manRevisionDate, ".</strong></font></td>\n",
  		"</tr>\n",
  		"</table>");
  }
  
	tree.document.write(
		"</body>\n",
		"</html>\n");
}

function manTreeAddNodeTitle(title, bullet)
{
	var bullet_html = ""	
	if (bullet == top.manHasBullet)
	  bullet_html = "    <td width='10'></td>\n";
	  
	tree.manTree +=
    "  <tr>\n" +
      bullet_html +
      "    <td align='center'><font face='Helvetica,Arial' size='2'><strong>" + title + "</strong></font></td>\n" +
    "  </tr>\n";
}

function manTreeAddNode(bullet, cont, title, book)
{
	if (!book)
  	book = "";
	else
  	book = "#" + book;
		
	var bullet_html = ""	
	if (bullet == top.manHasBullet)
	  bullet_html = "    <td width='10'><img src='man/bullet.gif' width='7' height='7'></td>\n";
	else if (bullet == top.manSkipBullet)
	  bullet_html = "    <td width='10'></td>\n";
	
	tree.manTree +=
    "  <tr>\n" +
      bullet_html +
      "    <td><font face='Helvetica,Arial' size='2'><a href='" + cont + ".html" + book + "'>" + title + "</a></font></td>\n" +
    "  </tr>\n";
}

function manTreeAddSeparator(bullet)
{
	if (bullet == top.manHasBullet)
	{
  	tree.manTree +=
      "  <tr>\n" +
        "    <td></td>\n" +
        "    <td><hr></td>\n" +
      "  </tr>\n";
	}
	else if (bullet == top.manSkipBullet)
	{
  	tree.manTree +=
      "  <tr>\n" +
        "    <td></td>\n" +
      "  </tr>\n";
	}
	else
	{
  	tree.manTree +=
      "  <tr>\n" +
        "    <td><hr></td>\n" +
      "  </tr>\n";
	}
}

