/*
* macros.h
* definicao das macros que acessam a estrutrura de dados do IUP definidas
* no arquivo global.h
* Carlos Henrique Levy
* 03 Sep 92
*/

#ifndef __MACROSH__
#define __MACROSH__

#define symb_name(s)	((s)->nm)
#define symb_info(s)	((s)->info)
#define symb_aloc(s)	((s)->aloc)
#ifndef next
#define next(s)		((s)->n)
#endif
#define symb_table(l,pos)   ((l)->table[pos])
#define symb_size(l)        ((l)->size)
#define forallsymb(l,pos,s) for (s=symb_table(l,pos); s; s=next(s))


#define foreachchild(c,n) for (c=child(n); c; c=brother(c))
#define child(_)         ((_)->firstchild)
#define parent(_)        ((_)->parent)
#define brother(_)       ((_)->next)
#define type(n)          ((n)->iet)
#define hclass(n)        ((n)->iclass)
#define env(n)           ((n)->enviroment)
#define number(n)        ((n)->ident)
#define handle(n)        ((n)->handle)
#define usersize(n)      ((n)->haveusersize)
#define posx(n)          ((n)->x)
#define posy(n)          ((n)->y)
#define naturalsize(n)   ((n)->natural)
#define naturalwidth(n)  ((n)->natural.width)
#define naturalheight(n) ((n)->natural.height)
#define currentwidth(n)  ((n)->current.width)
#define currentheight(n) ((n)->current.height)

#define parameters(n)    ((n)->attrib)

#define color_red(_)     ((unsigned int)atoi(IupGetAttribute((_),IUP_RED)))
#define color_green(_)   ((unsigned int)atoi(IupGetAttribute((_),IUP_GREEN)))
#define color_blue(_)    ((unsigned int)atoi(IupGetAttribute((_),IUP_BLUE)))

#define image_data(_)    ((_)->attrib.data)
#define image_width(_)   ((unsigned int)atoi(IupGetAttribute((_),IUP_WIDTH)))
#define image_height(_)  ((unsigned int)atoi(IupGetAttribute((_),IUP_HEIGHT)))

#define button_data(_)   ((_)->attrib.data)
#define button_text(_)   (IupGetAttribute((_),IUP_TITLE))
#define button_cb(_)     (IupGetAttribute((_),IUP_ACTION))

#define canvas_data(_)    ((_)->attrib.data)
#define canvas_repaint(_) (IupGetAttribute((_),IUP_ACTION))
#define canvas_resize(_)  (IupGetAttribute((_),IUP_RESIZE_CB))
#define canvas_mousemv(_) (IupGetAttribute((_),IUP_MOTION_CB))
#define canvas_button(_)  (IupGetAttribute((_),IUP_BUTTON_CB))

#define item_text(_)     (IupGetAttribute((_),IUP_TITLE))
#define item_cb(_)       (IupGetAttribute((_),IUP_ACTION))
#define submenu_text(_)  (IupGetAttribute((_),IUP_TITLE))

#define keyaction_list(n) ((n)->attrib.k.list)

#define ddlist_data(n)   ((n)->attrib.lst.dddata)
#define list_data(n)     ((n)->attrib.lst.data)
#define list_cb(_)       (IupGetAttribute((_),IUP_ACTION))

#define label_text(_)    (IupGetAttribute((_),IUP_TITLE))

#define text_data(_)     ((_)->attrib.data)
#define text_cb(_)       (IupGetAttribute((_),IUP_ACTION))
#define text_oldproc(n)  (text_data(n))
#define text_handle(n)   (text_data(n))

#define matrix_data(_)   ((_)->attrib.data)

#define dialog_data(_)   ((_)->attrib.data)
#define dialog_close(_)  (IupGetAttribute((_),IUP_CLOSE_CB))


#endif

