/*==============================================================================
*NOME:   CALLBACKS.H
*
*  Projeto:  Editor 2D
*
*  Verso:              V 1.00
*  Autores :   Juliana Carpes Imperial        - 9714169-4
*              Marcelo Gattass
*
*Descrio do mdulo de declarao
*     Objetivo:
*        - Definir as callbacks de interface.
*=============================================================================*/

#if !defined( callbacks_MOD )
#define       callbacks_MOD

#include <iup.h>

/* strings para envio de mensagens */
#define SZ_CGI2000 "CGI2000"
#define SZ_TCHAU   "Tchau!!\nAt Logo!!"
#define SZ_JULIANA "Trabalho 3: Editor\n Aluno: Juliana Carpes Imperial \
                    \n Matrcula: 9714169-4\n Verso: V1.00"
#define SZ_ARQ_LET "Nao foi possivel ler do arquivo de objetos!"
#define SZ_ARQ_ESC "Nao foi possivel escrever no arquivo de objetos!"
#define SZ_SEL_ARQ "Selecione o arquivo "
#define SZ_ARQ_EDT "*.edt"
#define SZ_ARQS_ED "Aquivos do Editor "
#define SZ_HELP    "Leia o arquivo readme.txt!!"


int open_cb( Ihandle* self ) ;
int save_cb( Ihandle* self ) ;
int exit_cb( Ihandle* self );
int info_cb(void);
int button_cb(Ihandle* ,int ,int ,int ,int );
int motion_cb(Ihandle* ,int ,int );
int resize_cb(Ihandle* ,int ,int );
int repaint_cb(Ihandle* );
int sel_cb(Ihandle* ,int );
int rect_cb(Ihandle* ,int );
int ellipse_cb(Ihandle* ,int );
int triang_cb(Ihandle* ,int );


/*==============================================================================
*Nome: iExclusaoCb
*Descrio da Funo: callback para excluir um objeto da lista.
*
*Parmetros recebidos:
*   Tog    - handle IUP do toggle e
*   iValor - = 1 se toggle foi para o estado on; e 0 se foi para o estado off.
* 
*Valor retornado
*   valor padro para o IUP.
*=============================================================================*/

int iExclusaoCb( Ihandle* Tog   ,
                 int      iValor ) ;


/*==============================================================================
*Nome: iNovoCb
*Descrio da Funo: callback de comear nova edio.
*
*Parmetro recebido:
*   self - o prprio item de menu.
* 
*Valor retornado
*   valor padro para o IUP.
*=============================================================================*/

int iNovoCb( Ihandle* self ) ;


/*==============================================================================
*Nome: iSalvarComoCb
*Descrio da Funo: callback de salvarcomo.
*
*Parmetro recebido:
*   self - o prprio item de menu.
* 
*Valor retornado
*   valor padro para o IUP.
*=============================================================================*/

int iSalvarComoCb( Ihandle* self ) ;


/*==============================================================================
*Nome: iAjudaCb
*Descrio da Funo: callback de ajuda.
* 
*Valor retornado
*   valor padro para o IUP.
*=============================================================================*/

int iAjudaCb( void ) ;


/*==============================================================================
*Nome: iSelBotaoCb
*Descrio da Funo: callback de boto no modo de seleo.
*
*Parmetros recebidos:
*   IupCanvas - handle IUP do canvas;
*   iBotao    - ID do boto;
*   iPress    - indica se botao foi pressionado ou solto;
*   iCoordX   - coordenada X do mouse e 
*   iCoordY   - coordenada Y do mouse.
* 
*Valor retornado
*   valor padro para o IUP.
*=============================================================================*/

int iSelBotaoCb( Ihandle* IupCanvas , 
                 int      iBotao    , 
                 int      iPress    , 
                 int      iCoordX   ,
                 int      iCoordY    ) ;


/*==============================================================================
*Nome: iExcBotaoCb
*Descrio da Funo: callback de boto no modo de excluso.
*
*Parmetros recebidos:
*   IupCanvas - handle IUP do canvas;
*   iBotao    - ID do boto;
*   iPress    - indica se botao foi pressionado ou solto;
*   iCoordX   - coordenada X do mouse e 
*   iCoordY   - coordenada Y do mouse.
* 
*Valor retornado
*   valor padro para o IUP.
*=============================================================================*/

int iExcBotaoCb( Ihandle* IupCanvas , 
                 int      iBotao    , 
                 int      iPress    , 
                 int      iCoordX   ,
                 int      iCoordY    ) ;


/*==============================================================================
*Nome: iRetBotaoCb
*Descrio da Funo: callback de boto no modo de retngulo.
*
*Parmetros recebidos:
*   IupCanvas - handle IUP do canvas;
*   iBotao    - ID do boto;
*   iPress    - indica se botao foi pressionado ou solto;
*   iCoordX   - coordenada X do mouse e 
*   iCoordY   - coordenada Y do mouse.
* 
*Valor retornado
*   valor padro para o IUP.
*=============================================================================*/

int iRetBotaoCb( Ihandle* IupCanvas , 
                 int      iBotao    , 
                 int      iPress    , 
                 int      iCoordX   ,
                 int      iCoordY    ) ;


/*==============================================================================
*Nome: iEliBotaoCb
*Descrio da Funo: callback de boto no modo de elipse.
*
*Parmetros recebidos:
*   IupCanvas - handle IUP do canvas;
*   iBotao    - ID do boto;
*   iPress    - indica se botao foi pressionado ou solto;
*   iCoordX   - coordenada X do mouse e 
*   iCoordY   - coordenada Y do mouse.
* 
*Valor retornado
*   valor padro para o IUP.
*=============================================================================*/

int iEliBotaoCb( Ihandle* IupCanvas , 
                 int      iBotao    , 
                 int      iPress    , 
                 int      iCoordX   ,
                 int      iCoordY    ) ;


/*==============================================================================
*Nome: iTriBotaoCb
*Descrio da Funo: callback de boto no modo de tringulo.
*
*Parmetros recebidos:
*   IupCanvas - handle IUP do canvas;
*   iBotao    - ID do boto;
*   iPress    - indica se botao foi pressionado ou solto;
*   iCoordX   - coordenada X do mouse e 
*   iCoordY   - coordenada Y do mouse.
* 
*Valor retornado
*   valor padro para o IUP.
*=============================================================================*/

int iTriBotaoCb( Ihandle* IupCanvas , 
                 int      iBotao    , 
                 int      iPress    , 
                 int      iCoordX   ,
                 int      iCoordY    ) ;


/*==============================================================================
*Nome: iTransMoveCb
*Descrio da Funo: callback de movimento de mouse na translao.
*
*Parmetros recebidos:
*   IupCanvas - handle IUP do canvas;
*   iCoordX   - coordenada X do mouse e 
*   iCoordY   - coordenada Y do mouse.
* 
*Valor retornado
*   valor padro para o IUP.
*=============================================================================*/

int iTransMoveCb( Ihandle* IupCanvas , 
                  int      iCoordX   , 
                  int      iCoordY    ) ;


/*==============================================================================
*Nome: iEscMoveCb
*Descrio da Funo: callback de movimento de mouse na escala
*
*Parmetros recebidos:
*   IupCanvas - handle IUP do canvas;
*   iCoordX   - coordenada X do mouse e 
*   iCoordY   - coordenada Y do mouse.
* 
*Valor retornado
*   valor padro para o IUP.
*=============================================================================*/

int iEscMoveCb( Ihandle* IupCanvas , 
                int      iCoordX   , 
                int      iCoordY    ) ;


/*==============================================================================
*Nome: iRetMoveCb
*Descrio da Funo: callback de movimento de mouse no modo de retngulo.
*
*Parmetros recebidos:
*   IupCanvas - handle IUP do canvas ;
*   iCoordX   - coordenada X do mouse e 
*   iCoordY   - coordenada Y do mouse.
* 
*Valor retornado
*   valor padro para o IUP.
*=============================================================================*/

int iRetMoveCb( Ihandle* IupCanvas , 
                int      iCoordX   , 
                int      iCoordY    ) ;


/*==============================================================================
*Nome: iEliMoveCb
*Descrio da Funo: callback de movimento de mouse no modo de elipse.
*
*Parmetros recebidos:
*   IupCanvas - handle IUP do canvas;
*   iCoordX   - coordenada X do mouse e 
*   iCoordY   - coordenada Y do mouse.
* 
*Valor retornado
*   valor padro para o IUP.
*=============================================================================*/

int iEliMoveCb( Ihandle* IupCanvas , 
                int      iCoordX   , 
                int      iCoordY    ) ;


/*==============================================================================
*Nome: iTriMoveCb
*Descrio da Funo: callback de movimento de mouse no modo de tringulo.
*
*Parmetros recebidos:
*   IupCanvas - handle IUP do canvas;
*   iCoordX   - coordenada X do mouse e 
*   iCoordY   - coordenada Y do mouse.
* 
*Valor retornado
*   valor padro para o IUP.
*=============================================================================*/

int iTriMoveCb( Ihandle* IupCanvas , 
                int      iCoordX   , 
                int      iCoordY    ) ;


#endif

/* callbacks.h */