/** MODIFICADO POR JULIANA **/

/**************************************
 * Includes de bibliotecas do TecGraf *
 **************************************/

#include <stdlib.h>

#include "canvas.h"
#include "interface.h"
#include "images.h"
#include "callbacks.h"
#include "operacao.h"
#include "cd.h"


/*
%F Cria radio de selecao: sel, rect, ellipse, triang
*/
static Ihandle * radioSelection()
{ 
    /* Radio que contem a selecao do modo de interacao com usuario */
    Ihandle * sel_tog      = IupToggle ( "Sel",     "sel_act");
    Ihandle * del_tog      = IupToggle ( "Del",  "del_act");

    Ihandle * rect_tog    = IupToggle ( "Rect",    "rect_act");
    Ihandle * ellipse_tog = IupToggle ( "Ellipse", "ellipse_act");
    Ihandle * triang_tog  = IupToggle ( "Triang",  "triang_act");


    Ihandle * sel_hbox = IupHbox ( 
        IupFrame(IupHbox(sel_tog, del_tog, NULL)),
        IupFrame(IupHbox(rect_tog, ellipse_tog, triang_tog, NULL)), 
        IupFill(),
        NULL);

    Ihandle * mode_rad = IupRadio( IupFrame(sel_hbox) );

    IupSetHandle("sel",imageSel());
    IupSetAttribute(sel_tog, IUP_IMAGE, "sel");
    IupSetHandle("sel_press",imageSelPress());
    IupSetAttribute(sel_tog, IUP_IMPRESS, "sel_press");

    IupSetHandle("del",imageDel());
    IupSetAttribute(del_tog, IUP_IMAGE, "del");
    IupSetHandle("del_press",imageDelPress());
    IupSetAttribute(del_tog, IUP_IMPRESS, "del_press");
    IupSetHandle("del_inactive",imageDelInactive());
    IupSetAttribute(del_tog, IUP_IMINACTIVE, "del_inactive");


    IupSetHandle("rect",imageRect());
    IupSetAttribute(rect_tog, IUP_IMAGE, "rect");

    IupSetHandle("rect_press",imageRectPress());
    IupSetAttribute(rect_tog, IUP_IMPRESS, "rect_press");

    IupSetHandle("ellipse",imageEllipse());
    IupSetAttribute(ellipse_tog, IUP_IMAGE, "ellipse");

    IupSetHandle("ellipse_press",imageEllipsePress());
    IupSetAttribute(ellipse_tog, IUP_IMPRESS, "ellipse_press");

    IupSetHandle("triang",imageTriang());
    IupSetAttribute(triang_tog, IUP_IMAGE, "triang");

    IupSetHandle("triang_press",imageTriangPress());
    IupSetAttribute(triang_tog, IUP_IMPRESS, "triang_press");

    return mode_rad;
}

    
/*
%F Cria o dialogo principal
*/
void initInterface(void)
{
    Ihandle * mode_rad = radioSelection();

    /* Criando os menus --------------------------------------------------------*/

    /* Criando o menu de arquivos */
    Ihandle* item_novo        = IupItem( "&New...", "AtoNovo" ) ;
    Ihandle* open_item        = IupItem( "&Open...", "open_act" ) ;
    Ihandle* save_item        = IupItem( "&Save"   , "save_act" ) ;
    Ihandle* item_salvar_como = IupItem( "Save &As...", "AtoSalvarComo" ) ;
    Ihandle* exit_item        = IupItem( "&Exit", "exit_act" ) ;
    Ihandle* arq_menu         = IupMenu( item_novo, open_item, IupSeparator( ), 
                                         save_item, item_salvar_como,
                                         IupSeparator( ), exit_item, NULL ) ;

    /* Criando o menu de barra */
    Ihandle* arq_submenu = IupSubmenu( "&File", arq_menu ) ;
    Ihandle* info_item   = IupItem( "&Info", "info_act" ) ;
    Ihandle* ItemAjuda   = IupItem( "&Help", "AtoAjuda" ) ;
    Ihandle* main_menu   = IupMenu( arq_submenu, info_item, ItemAjuda, NULL ) ;

    /*  Criando o canvas (CD)  */
    Ihandle * iup_canvas = IupCanvas("repaint_act");

    /* Dialogo principal contendo os botoes, o menu e o Canvas */
    Ihandle * main_vbox = IupVbox(mode_rad, IupFrame(iup_canvas),NULL);
    Ihandle * main_dlg  = IupDialog(main_vbox);

    tpListaObjs* MeusObjs = Inicializar( ) ; /* inicializa lista */

/* atributos para comear nova edio */
   IupSetAttribute( item_novo, SZ_OBJETOS, ( char* )MeusObjs ) ;
   IupSetAttribute( item_novo, "CanvasContext", ( char* )iup_canvas ) ;

/* atributos para abrir arquivo */
   IupSetAttribute( open_item, SZ_OBJETOS, ( char* )MeusObjs ) ;
   IupSetAttribute( open_item, "CanvasContext", ( char* )iup_canvas ) ;

/* atributos para salvar arquivo */
   IupSetAttribute( item_salvar_como, SZ_OBJETOS, ( char* )MeusObjs ) ;
   IupSetAttribute( save_item, SZ_OBJETOS, ( char* )MeusObjs ) ;

/* atributos para sair do programa */
   IupSetAttribute( exit_item, SZ_OBJETOS, ( char* )MeusObjs ) ;
   IupSetAttribute( exit_item, "CanvasContext", ( char* )iup_canvas ) ;

    /* Atributos do Canvas */
    IupSetAttribute(iup_canvas,IUP_RESIZE_CB,"resize_act");
    IupSetAttribute(iup_canvas,IUP_BUTTON_CB,"button_act");
    IupSetAttribute(iup_canvas,IUP_MOTION_CB,"motion_act");
    IupSetAttribute(iup_canvas,IUP_RASTERSIZE,"512 x256");

    IupSetAttribute( iup_canvas, SZ_OBJETOS, ( char* )MeusObjs ) ;

    /* Atributos do dialogo */
    IupSetAttribute(main_dlg, IUP_TITLE, "Editor de Objetos");
    IupSetHandle("main_menu_handle", main_menu);
    IupSetAttribute(main_dlg, IUP_MENU, "main_menu_handle");

    /* exibe o dialogo */
    IupShow(main_dlg);

    canvasCreate(iup_canvas);

    return;
}


/*
%F Desenha os objetos
*/
int objDraw( Ihandle*     IupCanvas ,
             tpListaObjs* MeusObjs   ) {

   int i        , /* contador auxiliar */
       iNumObjs ; /* nmero de objetos na lista */

   iNumObjs = iDarNumObjs( MeusObjs ) ; /* pega nmero de objetos */

/* desseleciona quem estiver selecionado */
   Desselecionar( -1, MeusObjs, IupCanvas ) ;
   
   canvasClear( IupCanvas ) ; /* apaga o que est no canvas */
   
/* redesenha todos os objetos da lista */
   for ( i = 0 ; i < iNumObjs ; i++ ) {
      DesenharObjeto( IupCanvas, DarObjeto( MeusObjs, i ) ) ;  
   } /* for */

   return i ;
}


/*==============================================================================
*Nome: szMenu
*=============================================================================*/

char* szMenu( char* szOperacao ) {

   Ihandle* filedlg = IupFileDlg( ) ; /* tipo do IUP para dialogo de arquivos */
   char*    szNomArq ;
     
/* define os atributos do dialogo de arquivos */
   IupSetAttribute( filedlg, IUP_DIALOGTYPE, szOperacao ) ; 
   IupSetAttribute( filedlg, IUP_TITLE, SZ_SEL_ARQ ) ; 
   IupSetAttribute( filedlg, IUP_FILTER, SZ_ARQ_EDT ) ; 
   IupSetAttribute( filedlg, IUP_FILTERINFO, SZ_ARQS_ED ) ; 

/* mostra o dialog na tela  no modo modal */
   IupPopup( filedlg, IUP_CENTER, IUP_CENTER ) ;

   szNomArq = IupGetAttribute( filedlg, IUP_VALUE ) ;
   szGuardarNomArq( szNomArq ) ;
  
/* retorna o nome do arquivo selecionado */
   return szNomArq ; 

} /* szMenu */


/*==============================================================================
*Nome: DesenharObjeto
*=============================================================================*/

void DesenharObjeto( Ihandle* IupCanvas ,
                     tpObjeto Objeto     ) {

   tpTipoObj Tipo     = DarTipo( Objeto )     ; /* tipo do objeto */
   int       iCoordX1 = iDarCoordX1( Objeto ) , /* X1 do objeto */
             iCoordX2 = iDarCoordX2( Objeto ) , /* X2 do objeto */
             iCoordX3 = iDarCoordX3( Objeto ) , /* X3 do objeto */
             iCoordY1 = iDarCoordY1( Objeto ) , /* Y1 do objeto */
             iCoordY2 = iDarCoordY2( Objeto ) , /* Y2 do objeto */
             iCoordY3 = iDarCoordY3( Objeto ) ; /* Y3 do objeto */

   switch ( Tipo ) { 
         
      case ID_Retangulo : /* desenha o retngulo */
             
         canvasDrawRect( IupCanvas, iCoordX1, iCoordY1, iCoordX2, iCoordY2 ) ; 
         break ;
         
      case ID_Elipse :    /* desenha a elipse */
            
         canvasDrawEllipse( IupCanvas, iCoordX1, iCoordY1, 
                                       iCoordX2, iCoordY2 ) ;
         break ; 
         
      case ID_Triangulo : /* desenha o tringulo */
            
         canvasDrawLine( IupCanvas, iCoordX1, iCoordY1, iCoordX2, iCoordY2 ) ; 
         canvasDrawLine( IupCanvas, iCoordX2, iCoordY2, iCoordX3, iCoordY3 ) ;
         canvasDrawLine( IupCanvas, iCoordX3, iCoordY3, iCoordX1, iCoordY1 ) ;
         break ;

      default :  /* tipo invlido, nunca acontece */
         break ;
          
   } /* switch */

} /* DesenharObjeto */


/*==============================================================================
*Nome: DesenharObjTemp
*=============================================================================*/

void DesenharObjTemp( Ihandle*  IupCanvas ,
                      tpTipoObj Tipo      ,
                      int       iCoordX1  ,
                      int       iCoordX2  ,
                      int       iCoordX3  ,
                      int       iCoordY1  ,
                      int       iCoordY2  ,
                      int       iCoordY3   ) {

   switch ( Tipo ) { 
         
      case ID_Retangulo : /* desenha o retngulo temporrio */
             
         canvasDrawTempRect( IupCanvas, iCoordX1, iCoordY1,
                                        iCoordX2, iCoordY2 ) ;
         break ;
         
      case ID_Elipse :    /* desenha a elipse temporria */
            
         canvasDrawTempEllipse( IupCanvas, iCoordX1, iCoordY1, 
                                           iCoordX2, iCoordY2 ) ;
         break ; 
         
      case ID_Triangulo : /* desenha o tringulo temporrio */
       
         cdBegin( CD_CLOSED_LINES ) ; 
         cdVertex( iCoordX1, iCoordY1 ) ;
         cdVertex( iCoordX2, iCoordY2 ) ;
         cdVertex( iCoordX3, iCoordY3 ) ;
         cdEnd( ) ; 
         break ;

      default :  /* tipo invlido, nunca acontece */
         break ;
          
   } /* switch */

} /* DesenharObjTemp */


/*==============================================================================
*Nome: Desselecionar
*=============================================================================*/

void Desselecionar( int          iIndice  ,
                    tpListaObjs* MeusObjs , 
                    Ihandle*     IupCanvas ) {

   static int iObjeto = -1 ; /* ndice inicial armazenado */

/* s desseleciona se objeto selecionado previamente existir e se ele no  o
   objeto selecionado atualmente */
   if ( iObjeto != iIndice 
     && iObjeto != -1 ) {
   
   /* pega os dados do objeto a ser desselecionado */ 
      tpObjeto Objeto  = DarObjeto( MeusObjs, iObjeto ) ;  
      
   /* desenha o objeto selecionado em vermelho */ 
      DesenharObjeto( IupCanvas, Objeto ) ;
       
   } /* if */

   iObjeto = iIndice ;      /* atualiza o objeto atualmente selecionado */
   iGuardarIdx( iIndice ) ; /* guarda ndice do objeto */

} /* Desselecionar */