/*==============================================================================
*NOME:   INTERFACE.H
*
*  Projeto:  Editor 2D
*
*  Verso:              V 1.00
*  Autores :   Juliana Carpes Imperial        - 9714169-4
*              Marcelo Gattass
*
*Descrio do mdulo de declarao
*     Objetivo:
*        - Definir funes para a interface do editor.
*=============================================================================*/

#if !defined( interface_MOD )
#define       interface_MOD

#include "objects.h"

#define SZ_OBJETOS "objetos"


void initInterface(void);

int objDraw( Ihandle*     IupCanvas ,
             tpListaObjs* MeusObjs   ) ;


/*==============================================================================
*Nome: szMenu
*Descrio da Funo: funo auxiliar para as callbacks de open e save.
*
*Parmetro recebido:
*   szOperacao - IUP_OPEN ou IUP_SAVE.
*
*Valor retornado
*   o nome do arquivo.
*=============================================================================*/

char* szMenu( char* szOperacao ) ;


/*==============================================================================
*Nome: DesenharObjeto
*Descrio da Funo: funo para desenhar um objeto.
*
*Parmetros recebidos:
*   IupCanvas - o handle do IUP canvas e
*   Objeto    - o objeto a ser desenhado.
*=============================================================================*/

void DesenharObjeto( Ihandle* IupCanvas ,
                     tpObjeto Objeto     ) ;


/*==============================================================================
*Nome: DesenharObjTemp
*Descrio da Funo: funo para desenhar um objeto temporrio.
*
*Parmetros recebidos:
*   IupCanvas - o handle do IUP canvas;
*   Tipo      - pode ser retngulo, elipse ou tringulo;
*   iCoordX1  - Coordenada X do ponto 1 do objeto;
*   iCoordX2  - Coordenada X do ponto 2 do objeto;
*   iCoordX3  - Coordenada X do ponto 3 do objeto (= -1 em elipse e retngulo);
*   iCoordY1  - Coordenada Y do ponto 1 do objeto;
*   iCoordY2  - Coordenada Y do ponto 2 do objeto e
*   iCoordY3  - Coordenada Y do ponto 3 do objeto (= -1 em elipse e retngulo).
*=============================================================================*/

void DesenharObjTemp( Ihandle*  IupCanvas ,
                      tpTipoObj Tipo      ,
                      int       iCoordX1  ,
                      int       iCoordX2  ,
                      int       iCoordX3  ,
                      int       iCoordY1  ,
                      int       iCoordY2  ,
                      int       iCoordY3   ) ;


/*==============================================================================
*Nome: Desselecionar
*Descrio da Funo: funo para desselecionar um objeto.
*
*Parmetros recebidos:
*   iIndice   - o ndice do novo objeto selecionado na lista de objetos;
*   MeusObjs  - a lista de objetos e
*   IupCanvas - o handle do IUP canvas.
*=============================================================================*/

void Desselecionar( int          iIndice  ,
                    tpListaObjs* MeusObjs ,
                    Ihandle*     IupCanvas ) ;


#endif

/* interface.h */