/** MODIFICADO POR JULIANA **/

/*
%M Modulo dos Objetos (Retangulo, Elipse e Trainagulo )
*/

#include <stdio.h>
#include <stdlib.h>
#include "objects.h"
#include "operacao.h"


/*
%F Le os objetos de um arquivo
*/
int objRead( char*        filename ,
             tpListaObjs* MeusObjs  ) {

/* tenta abrir o arquivo para leitura */
   FILE* pArquivo = fopen( filename, "rb" ) ;

   if ( pArquivo == NULL ) {                 /* testa se abriu */
      return -1 ;                            /* no abriu */ 
   } /* if */

/* tenta ler o contedo do arquivo */
   MeusObjs->iNumObjs = fread( MeusObjs->Objetos, sizeof( tpObjeto ), 
                               I_MAX_OBJS, pArquivo ) ;

   if ( ferror( pArquivo ) != 0 ) {          /* testa se leu */
      return -1 ;                            /* no leu */
   } /* if */
         
   fclose( pArquivo ) ;                      /* tenta fechar */       
   if ( ferror( pArquivo ) != 0 ) {          /* testa se fechou */
      return -1 ;                            /* no fechou */ 
   } /* if */

   return MeusObjs->iNumObjs ;               /* leu lista com sucesso */
}


/*
%F Grava os objetos num arquivo
*/
int objSave( char*        filename ,
             tpListaObjs* MeusObjs  ) {
 
/* tenta abrir o arquivo para escrita */
   FILE* pArquivo = fopen( filename, "wb" ) ;

   if ( pArquivo == NULL ) {                 /* testa se abriu */
      return -1 ;                            /* no abriu */ 
   } /* if */

/* tenta escrever o contedo do arquivo */
   fwrite( MeusObjs->Objetos, sizeof( tpObjeto ), MeusObjs->iNumObjs,
           pArquivo ) ;

   if ( ferror( pArquivo ) != 0 ) {          /* testa se escreveu */
      return -1 ;                            /* no escreveu */
   } /* if */

   fclose( pArquivo ) ;                      /* tenta fechar */
   if ( ferror( pArquivo ) != 0 ) {          /* testa se fechou */
      return -1 ;                            /* no fechou */
   } /* if */

   return MeusObjs->iNumObjs ;               /* escreveu lista com sucesso */
}


/*
%F Insere um retangulo na lista de objetos
*/
int objInsertRect( tpListaObjs* MeusObjs ,
                   int          x0       ,
                   int          y0       ,
                   int          x1       ,
                   int          y1        ) {

/* insere retngulo no fim da lista */
   InserirObj( MeusObjs, MeusObjs->iNumObjs, ID_Retangulo, x0, x1, -1,
                                                           y0, y1, -1 ) ;

   MeusObjs->iNumObjs++ ; /* aumenta nmero de objetos */

 printf("\n Insert rect [(%d,%d),(%d,%d)]", x0, y0, x1, y1 );

 return 1;

}


/*
%F Insere uma elipse na lista de objetos
*/
int objInsertEllipse( tpListaObjs* MeusObjs ,
                      int x0                ,
                      int y0                ,
                      int x1                ,
                      int y1                 ) {

/* insere elipse no fim da lista */
   InserirObj( MeusObjs, MeusObjs->iNumObjs, ID_Elipse, x0, x1, -1,
                                                        y0, y1, -1 ) ;

   MeusObjs->iNumObjs++ ; /* aumenta nmero de objetos */

 printf("\n Insert ellipse [(%d,%d),(%d,%d)]", x0, y0, x1, y1 );
 return 1;

}


int objInsertTriang( tpListaObjs* MeusObjs ,
                     int x0                ,
                     int y0                ,
                     int x1                ,
                     int y1                ,
                     int x2                ,
                     int y2                 ) {

/* insere tringulo no fim da lista */
   InserirObj( MeusObjs, MeusObjs->iNumObjs, ID_Triangulo, x0, x1, x2,
                                                           y0, y1, y2 ) ;

   MeusObjs->iNumObjs++ ; /* aumenta nmero de objetos */

 printf("\n Insert triang [(%d,%d),(%d,%d),(%d,%d)]", x0, y0, x1, y1, x2, y2 );
 return 1;

}


/*==============================================================================
*Nome: Inicializar
*=============================================================================*/

tpListaObjs* Inicializar( void ) {

/* inicializa lista de objetos */
   tpListaObjs* MeusObjs = ( tpListaObjs* )malloc( sizeof( tpListaObjs ) ) ;

   if ( MeusObjs != NULL ) {
      MeusObjs->iNumObjs = 0 ; /* inicializa nmero de objetos */
   } else {
      printf( SZ_MEM ) ;
   } /* if */

   return MeusObjs ;

} /* Inicializar */


/*==============================================================================
*Nome: ZerarObjetos
*=============================================================================*/

void ZerarObjetos( tpListaObjs* MeusObjs ) {
   MeusObjs->iNumObjs = 0 ;
} /* ZerarObjetos */


/*==============================================================================
*Nome: iDarCoordX1
*=============================================================================*/

int iDarCoordX1( tpObjeto Objeto ) {
   return Objeto.iCoordX1 ;
} /* iDarCoordX1 */


/*==============================================================================
*Nome: iDarCoordX2
*=============================================================================*/

int iDarCoordX2( tpObjeto Objeto ) {
   return Objeto.iCoordX2 ;
} /* iDarCoordX2 */


/*==============================================================================
*Nome: iDarCoordX3
*=============================================================================*/

int iDarCoordX3( tpObjeto Objeto ) {
   return Objeto.iCoordX3 ;
} /* iDarCoordX3 */


/*==============================================================================
*Nome: iDarCoordY1
*=============================================================================*/

int iDarCoordY1( tpObjeto Objeto ) {
   return Objeto.iCoordY1 ;
} /* iDarCoordY1 */


/*==============================================================================
*Nome: iDarCoordY2
*=============================================================================*/

int iDarCoordY2( tpObjeto Objeto ) {
   return Objeto.iCoordY2 ;
} /* iDarCoordY2 */


/*==============================================================================
*Nome: iDarCoordY3
*=============================================================================*/

int iDarCoordY3( tpObjeto Objeto ) {
   return Objeto.iCoordY3 ;
} /* iDarCoordY3 */


/*==============================================================================
*Nome: DarTipo
*=============================================================================*/

int DarTipo( tpObjeto Objeto ) {
   return Objeto.TipoObjeto ;
} /* DarTipo */


/*==============================================================================
*Nome: DarObjeto
*=============================================================================*/

tpObjeto DarObjeto( tpListaObjs* MeusObjs ,
                    int          iIndice   ) {
   return MeusObjs->Objetos[ iIndice ] ;
} /* DarObjeto */


/*==============================================================================
*Nome: iDarNumObjs
*=============================================================================*/

int iDarNumObjs( tpListaObjs* MeusObjs ) {
   return MeusObjs->iNumObjs ;
} /* iDarNumObjs */


/*==============================================================================
*Nome: iBuscarObj
*=============================================================================*/

int iBuscarObj( tpListaObjs* MeusObjs ,
                int          iCoordX  ,
                int          iCoordY   ) {

   int i ; /* contador auxiliar */

/* procura objeto no vetor */
   for ( i = MeusObjs->iNumObjs - 1 ;
         i >= 0 && iEstarFora( MeusObjs->Objetos[ i ], iCoordX, iCoordY ) ;
         i-- ) { }

/* se o ndice  o nmero de elementos, o objeto no est na lista */
   if ( i == MeusObjs->iNumObjs ) {
      return -1 ;         /* objeto no encontrado */
   } else {
      return i ;          /* objeto encontrado */
   } /* if */

} /* iBuscarObj */


/*==============================================================================
*Nome: InserirObj
*=============================================================================*/

void InserirObj( tpListaObjs* MeusObjs   ,
                 int          iIndice    ,
                 tpTipoObj    TipoObjeto ,
                 int          iCoordX1   ,
                 int          iCoordX2   ,
                 int          iCoordX3   ,
                 int          iCoordY1   ,
                 int          iCoordY2   ,
                 int          iCoordY3    ) {

/* insere objeto */
   MeusObjs->Objetos[ iIndice ].TipoObjeto = TipoObjeto ;
   MeusObjs->Objetos[ iIndice ].iCoordX1 = iCoordX1 ;
   MeusObjs->Objetos[ iIndice ].iCoordY1 = iCoordY1 ;
   MeusObjs->Objetos[ iIndice ].iCoordX2 = iCoordX2 ;
   MeusObjs->Objetos[ iIndice ].iCoordY2 = iCoordY2 ;
   MeusObjs->Objetos[ iIndice ].iCoordX3 = iCoordX3 ;
   MeusObjs->Objetos[ iIndice ].iCoordY3 = iCoordY3 ;

} /* InserirObj */


/*==============================================================================
*Nome: ExcluirObj
*=============================================================================*/

void ExcluirObj( tpListaObjs* MeusObjs ,
                 int          iIndice   ) {

   int i ;  /* contador de iteraes */

/* desloca todos os objetos de uma posio */
   for ( i = iIndice ; i < MeusObjs->iNumObjs - 1 ; i++ ) {
      MeusObjs->Objetos[ i ] = MeusObjs->Objetos[ i + 1 ] ;
   } /* for */

   MeusObjs->iNumObjs-- ; /* diminui o nmero de objetos da lista */

} /* ExcluirObj */
