/*==============================================================================
*NOME:   OPERACAO.C
*
*  Projeto:  Editor 2D
*
*  Verso:              V 1.00
*  Autor :   Juliana Carpes Imperial        - 9714169-4
*
*Descrio do mdulo de implementao
*     Objetivos:
*        - Implementar funo para selecionar um objeto; 
*        - Implementar funo para transladar um objeto;
*        - Definir funo para escalar um objeto e
*        - Implementar funes auxiliares para armazenar dados. 
*
*Modo de utilizar:
*        - Pesquisar em operacao.h a especificao das funes aqui
*          implementadas para seu correto uso.
*=============================================================================*/

#include <math.h>
#include "operacao.h"


/*==============================================================================
*Nome: iEstarFora
*=============================================================================*/

int iEstarFora( tpObjeto Objeto  ,
                int      iCoordX ,
                int      iCoordY   ) {

/* pega as coordenadas do objeto */
   int iCoordX1 = iDarCoordX1( Objeto ) ,
       iCoordX2 = iDarCoordX2( Objeto ) ,
       iCoordX3 = iDarCoordX3( Objeto ) ,
       iCoordY1 = iDarCoordY1( Objeto ) ,
       iCoordY2 = iDarCoordY2( Objeto ) ,
       iCoordY3 = iDarCoordY3( Objeto ) ;

   switch( DarTipo( Objeto ) ) {
                         
      case ID_Retangulo :    /* se for retngulo */
         
      /* testa se o mouse est dentro da figura retngulo */
         if ( ( ( iCoordX <= iCoordX1 
               && iCoordX >= iCoordX2 )
             || ( iCoordX >= iCoordX1 
               && iCoordX <= iCoordX2 ) )
           && ( ( iCoordY <= iCoordY1 
               && iCoordY >= iCoordY2 )
             || ( iCoordY >= iCoordY1 
               && iCoordY <= iCoordY2 ) ) ) {
            return 0 ;  /* est */
         } else {      
            return 1 ;  /* no est */
         } /* if */ 

      case ID_Elipse : {     /* se for elipse */
      
         double dA , /* o a da eq da elipse */
                dB , /* o b da eq da elipse */
                dR , /* varivel para testar se est dentro da elipse */
                dX , /* iCoordX deslocado em relao ao centro da elipse */
                dY ; /* iCoordY deslocado em relao ao centro da elipse */                                                       
         
      /* calcula o a e b da equao da elipse */
         dA = fabs( ( double )iCoordX1 - ( double )iCoordX2 ) / 2. ;
         dB = fabs( ( double )iCoordY1 - ( double )iCoordY2 ) / 2. ;
      
      /* desloca as coordenadas do mouse em relao ao centro da elipse */
         dX = ( double )iCoordX 
            - ( ( double )iCoordX1 + ( double )iCoordX2 ) / 2. ;
         dY = ( double )iCoordY
            - ( ( double )iCoordY1 + ( double )iCoordY2 ) / 2. ;

      /* testa se o mouse est dentro da figura elipse */
         dR = pow( dX / dA, 2. ) + pow( dY / dB, 2. ) ;    

         if ( dR <= 1. ) {
            return 0 ;
         } else {
            return 1 ;
         } /* if */ 

      } 

      case ID_Triangulo : {  /* se for tringulo */
         
      /* testa se o mouse est dentro da figura tringulo */
         double dT1 = ( ( double )iCoordX2 - ( double )iCoordX1 ) 
			           * ( ( double )iCoordY - ( double )iCoordY1 ) 
                    - ( ( double )iCoordX - ( double )iCoordX1 ) 
				        * ( ( double )iCoordY2 - ( double )iCoordY1 ) ,

                dT2 = ( ( double )iCoordX3 - ( double )iCoordX2 ) 
				        * ( ( double )iCoordY - ( double )iCoordY2 ) 
                    - ( ( double )iCoordX - ( double )iCoordX2 ) 
					     * ( ( double )iCoordY3 - ( double )iCoordY2 ) ,
         
                dT3 = ( ( double )iCoordX1 - ( double )iCoordX3 ) 
				        * ( ( double )iCoordY - ( double )iCoordY3 ) 
                    - ( ( double )iCoordX - ( double )iCoordX3 ) 
					     * ( ( double )iCoordY1 - ( double )iCoordY3 ) ;
         
         if ( dT1 * dT2 > 0.
           && dT1 * dT3 > 0.) {
            return 0 ;   /* est */
         } else {
            return 1 ;   /* no est */    
         } /* if */
      
      }   

      default :      /* objeto invlido, nunca acontecer */
         return 1 ;
      
   } /* switch */    

} /* iEstarFora */


/*==============================================================================
*Nome: TransladarObj  
*=============================================================================*/

void TransladarObj( int          iIndice  ,
                    tpListaObjs* MeusObjs ,
                    tpObjeto*    Objeto   ,
                    tpTipoObj*   Tipo     ,
                    int*         iCoordX1 ,
                    int*         iCoordX2 ,
                    int*         iCoordX3 ,
                    int*         iCoordY1 ,
                    int*         iCoordY2 ,
                    int*         iCoordY3 , 
                    int          iCoordX  ,
                    int          iCoordY   ) {


   *Objeto = DarObjeto( MeusObjs, iIndice ) ; /* pega o objeto */
   *Tipo = DarTipo( *Objeto ) ;               /* pega o tipo */
   
/* pega e translada pontos 1 e 2 dos objetos */
   *iCoordX1 = iDarCoordX1( *Objeto ) + iCoordX - iGuardarPontoX( -1 ) ;
   *iCoordX2 = iDarCoordX2( *Objeto ) + iCoordX - iGuardarPontoX( -1 ) ; 
   *iCoordY1 = iDarCoordY1( *Objeto ) + iCoordY - iGuardarPontoY( -1 ) ; 
   *iCoordY2 = iDarCoordY2( *Objeto ) + iCoordY - iGuardarPontoY( -1 ) ; 
   
   *iCoordX3 = iDarCoordX3( *Objeto ) ; /* pega X3 */
   *iCoordY3 = iDarCoordY3( *Objeto ) ; /* pega Y3 */
   
/* se o objeto  tringulo, translada tambm o ponto 3 */
   if ( *Tipo == ID_Triangulo ) {
      *iCoordX3 += iCoordX - iGuardarPontoX( -1 ) ; 
      *iCoordY3 += iCoordY - iGuardarPontoY( -1 ) ;
   } /* if */

} /* TransladarObj */


/*==============================================================================
*Nome: EscalarObj
*=============================================================================*/

void EscalarObj( int          iIndice  ,
                 tpListaObjs* MeusObjs ,
                 tpObjeto*    Objeto   ,
                 tpTipoObj*   Tipo     ,
                 int*         iCoordX1 ,
                 int*         iCoordX2 ,
                 int*         iCoordX3 ,
                 int*         iCoordY1 ,
                 int*         iCoordY2 ,
                 int*         iCoordY3 ,
                 int          iCoordX  ,
                 int          iCoordY   ) {

   *Objeto = DarObjeto( MeusObjs, iIndice ) ; /* pega o objeto */
   *Tipo = DarTipo( *Objeto ) ;               /* pega o tipo */

/* pega e modifica ponto 2 dos objetos */
   *iCoordX2 = iDarCoordX2( *Objeto ) + iCoordX - iGuardarPontoX( -1 ) ; 
   *iCoordY2 = iDarCoordY2( *Objeto ) + iCoordY - iGuardarPontoY( -1 ) ; 
   
   *iCoordX1 = iDarCoordX1( *Objeto ) ; /* pega X1 */
   *iCoordY1 = iDarCoordY1( *Objeto ) ; /* pega Y1 */
   *iCoordX3 = iDarCoordX3( *Objeto ) ; /* pega X3 */
   *iCoordY3 = iDarCoordY3( *Objeto ) ; /* pega Y3 */

/* se o objeto  tringulo, modifica tambm o ponto 3 */
   if ( *Tipo == ID_Triangulo ) {
      *iCoordX3 += iCoordX - iGuardarPontoX( -1 ) ; 
      *iCoordY3 += iCoordY - iGuardarPontoY( -1 ) ;
   } /* if */

} /* EscalarObj */


/*==============================================================================
*Nome: iGuardarPontoX
*=============================================================================*/

int iGuardarPontoX( int iX ) {
   static int iPtX ;
   
   if ( iX >= 0 ) { /* se a funo recebe -1, o valor de iX no  alterado */
      iPtX = iX ;
   } /* if */
   
   return iPtX ;
} /* iGuardarPontoX */


/*==============================================================================
*Nome: iGuardarPontoY
*=============================================================================*/

int iGuardarPontoY( int iY ) {
   static int iPtY ;

   if ( iY >= 0 ) { /* se a funo recebe -1, o valor de iY no  alterado */
      iPtY = iY ;
   } /* if */

   return iPtY ;
} /* iGuardarPontoY */


/*==============================================================================
*Nome: iGuardarIdx
*=============================================================================*/

int iGuardarIdx( int iIndice ) {
   static int iIdx ;

   if ( iIndice >= 0 ) { /* se a funo recebe -1, o valor de iIdx no  alterado */
      iIdx = iIndice ;
   } /* if */

   return iIdx ;
} /* iGuardarIdx */


/*==============================================================================
*Nome: szGuardarNomArq
*=============================================================================*/

char* szGuardarNomArq( char* szNomArq ) {
   static char* szNomeArq ;

/* se a funo recebe 0, o valor de szNomeArq no  alterado */
   if ( szNomArq != 0 ) { 
      szNomeArq = szNomArq ;
   } /* if */

   return szNomeArq ;
} /* szGuardarNomArq */


/* operacao.c */