/*==============================================================================
*NOME:   OPERACAO.H
*
*  Projeto:  Editor 2D
*
*  Verso:              V 1.00
*  Autor :   Juliana Carpes Imperial        - 9714169-4
*
*Descrio do mdulo de declarao
*     Objetivos:
*        - Definir funo para selecionar um objeto;
*        - Definir funo para transladar um objeto;
*        - Definir funo para escalar um objeto e
*        - Definir funes auxiliares para armazenar dados. 
*=============================================================================*/

#if !defined( operacao_MOD )
#define       operacao_MOD


#include "objects.h"


/*==============================================================================
*Nome: iEstarFora
*Descrio da Funo: funo para verificar se um objeto est ou no 
*                     selecionado.
*
*Parmetros recebidos
*   Objeto  - um objeto da lista;
*   iCoordX - a coordenada X de onde est o mouse e
*   iCoordY - a coordenada Y de onde est o mouse.
*
*Valor retornado
*   -> 1 se o objeto no est marcado ou
*   -> 0 se o objeto est marcado.
*=============================================================================*/

int iEstarFora( tpObjeto Objeto  ,
                int      iCoordX ,
                int      iCoordY   ) ;


/*==============================================================================
*Nome: TransladarObj
*Descrio da Funo: funo para transladar um objeto.
*
*Parmetros recebidos
*   iIndice  - ndice do objeto a ser transladado e
*   MeusObjs - lista de objetos.
*
*Parmetros retornados
*   Objeto   - o objeto transladado;
*   Tipo     - o tipo do objeto;
*   iCoordX1 - X1 do objeto;
*   iCoordX2 - X2 do objeto;
*   iCoordX3 - X3 do objeto (= -1 em retngulos e elpses);
*   iCoordY1 - Y1 do objeto;
*   iCoordY2 - Y2 do objeto;
*   iCoordY3 - Y3 do objeto (= -1 em retngulos e elpses);
*   iCoordX  - X do mouse e
*   iCoordY  - Y do mouse.  
*=============================================================================*/

void TransladarObj( int          iIndice  ,
                    tpListaObjs* MeusObjs ,
                    tpObjeto*    Objeto   ,
                    tpTipoObj*   Tipo     ,
                    int*         iCoordX1 ,
                    int*         iCoordX2 ,
                    int*         iCoordX3 ,
                    int*         iCoordY1 ,
                    int*         iCoordY2 ,
                    int*         iCoordY3 ,
                    int          iCoordX  ,
                    int          iCoordY   ) ;


/*==============================================================================
*Nome: EscalarObj
*Descrio da Funo: funo para escalar um objeto.
*
*Parmetros recebidos
*   iIndice  - ndice do objeto a ser transladado e
*   MeusObjs - lista de objetos.
*
*Parmetros retornados
*   Objeto   - o objeto transladado;
*   Tipo     - o tipo do objeto;
*   iCoordX1 - X1 do objeto;
*   iCoordX2 - X2 do objeto;
*   iCoordX3 - X3 do objeto (= -1 em retngulos e elpses);
*   iCoordY1 - Y1 do objeto;
*   iCoordY2 - Y2 do objeto;
*   iCoordY3 - Y3 do objeto (= -1 em retngulos e elpses);
*   iCoordX  - X do mouse e
*   iCoordY  - Y do mouse.  
*=============================================================================*/

void EscalarObj( int          iIndice  ,
                 tpListaObjs* MeusObjs ,
                 tpObjeto*    Objeto   ,
                 tpTipoObj*   Tipo     ,
                 int*         iCoordX1 ,
                 int*         iCoordX2 ,
                 int*         iCoordX3 ,
                 int*         iCoordY1 ,
                 int*         iCoordY2 ,
                 int*         iCoordY3 ,
                 int          iCoordX  ,
                 int          iCoordY   ) ;


/*==============================================================================
*Nome: iGuardarPontoX
*Descrio da Funo: retorna coordenada x armazenada.
*
*Parmetro recebido
*   iX - uma coordenada x a ser armazenada.
*
*Valor retornado
*   -> o valor armazenado se iX >= 0 ou
*   -> o ltimo valor armazenado se iX < 0.
*=============================================================================*/

int iGuardarPontoX( int iX ) ;


/*==============================================================================
*Nome: iGuardarPontoY
*Descrio da Funo: retorna coordenada y armazenada.
*
*Parmetro recebido
*   iY - uma coordenada y a ser armazenada.
*
*Valor retornado
*   -> o valor armazenado se iY >= 0 ou
*   -> o ltimo valor armazenado se iY < 0.
*=============================================================================*/

int iGuardarPontoY( int iY ) ;


/*==============================================================================
*Nome: iGuardarIdx
*Descrio da Funo: retorna um ndice de objeto armazenado.
*
*Parmetro recebido
*   iIndice - um ndice de objeto a ser armazenado.
*
*Valor retornado
*   -> o valor armazenado se iIndice >= 0 ou
*   -> o ltimo valor armazenado se iIndice < 0.
*=============================================================================*/

int iGuardarIdx( int iIndice ) ;


/*==============================================================================
*Nome: szGuardarNomArq
*Descrio da Funo: retorna cadeia de nome de arquivo armazenada.
*
*Parmetro recebido
*   szNomArq: cadeia a ser armazenada.
*
*Valor retornado
*   -> o nome armazenado se szNomArq != 0 ou
*   -> o ltimo nome armazenado se szNomArq = 0.
*=============================================================================*/

char* szGuardarNomArq( char* szNomArq ) ;


#endif


/* operacao.h */
